
(ns body.ear)
(use 'cortex.world)
(use 'cortex.import)
(use 'clojure.contrib.def)
(cortex.import/mega-import-jme3)
(rlm.rlm-commands/help)
(import java.nio.ByteBuffer)
(import java.awt.image.BufferedImage)
(import java.awt.Color)
(import java.awt.Dimension)
(import java.awt.Graphics)
(import java.awt.Graphics2D)
(import java.awt.event.WindowAdapter)
(import java.awt.event.WindowEvent)
(import java.awt.image.BufferedImage)
(import java.nio.ByteBuffer)
(import javax.swing.JFrame)
(import javax.swing.JPanel)
(import javax.swing.SwingUtilities)
(import javax.swing.ImageIcon)
(import javax.swing.JOptionPane)
(import java.awt.image.ImageObserver)
(in-ns 'body.ear)
(import 'com.jme3.capture.SoundProcessor)


(defn sound-processor
  "deals with converting ByteBuffers into Vectors of Bytes so that the
  continuation functions can be defined in terms of immutable stuff."
  [continuation]
  (proxy [SoundProcessor] []
    (cleanup [])
    (process
     [#^ByteBuffer audioSamples numSamples]
     
     (let [byte-array (make-array Byte numSamples)]
       (.get audioSamples byte-array 0 numSamples)
       
       (continuation
	(vec byte-array))))))
	 

(defn add-ear 
  "add an ear to the world.  The continuation function will be called
  on the FFT or the sounds which the ear hears in the given
  timeframe. Sound is 3D."
  [world ear continuation]
  (let [listener (Listener.)
	renderer (.getAudioRenderer world)]
    (.addListener renderer listener)
    (.registerSoundProcessor renderer listener (sound-processor continuation))
    listener))
